<?php

use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Domain\Delegate\Models\DelegateFormStep;
use EventPortal\Domain\Event\Form\Enums\State;
use EventPortal\Domain\Event\Form\Models\FormStep;

/** @var \Illuminate\Database\Eloquent\Factory $factory */

$factory->define(DelegateFormStep::class, static function (): array {
    return [
        'state' => State::Complete()->getValue(),
        'delegate_id' => static function (): int {
            return factory(Delegate::class)->create()->id;
        },
        'form_step_id' => static function (): int {
            return factory(FormStep::class)->create()->id;
        },
    ];
});

$factory->state(DelegateFormStep::class, 'partial', function () {
    return [
        'state' => State::Partial()->getValue(),
    ];
});
