<?php

namespace EventPortal\Domain\Team\Handlers;

use Closure;
use EventPortal\Domain\Form\Payload;
use EventPortal\Domain\Team\Models\Team;
use EventPortal\Domain\User\Models\User;

class AssignTeams
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $teams = Team::query()->find($payload->pluckArrayValues('teams'));

        if ($teams !== null) {
            if ($payload->getModel() instanceof User) {
                $payload->getModel()->admin->sync($teams);

                return $next($payload);
            }

            $payload->getModel()->teams()->sync($teams);
        }

        return $next($payload);
    }
}
