<?php

namespace EventPortal\Tests\Unit\EventVenue;

use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\EventVenue\Actions\AssociateToEvent;
use EventPortal\Domain\EventVenue\Actions\DisassociateFromEvent;
use EventPortal\Domain\Venue\Models\Venue;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;

class DisassociateFromEventTest extends TestCase
{
    use RefreshDatabase;

    /** @test **/
    public function dissasociate_from_event()
    {
        $event = factory(Event::class)->create();
        [$speakerA, $speakerB, $speakerC] = factory(Venue::class, 3)->create();

        (new AssociateToEvent)->execute($event, [
            $speakerA->id,
            $speakerB->id,
            $speakerC->id,
        ]);

        (new DisassociateFromEvent)->execute($event, [
            $speakerA->id,
            $speakerC->id,
        ]);

        $this->assertEventMissingVenues($event, [$speakerA, $speakerC]);
        $this->assertEventHasVenue($event, $speakerB);
    }
}
